<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: tools/tool.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: tools/tool.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
* boilerplate for a tool module file
*
* contains classes that, when extended, enable your tool module with useful functions
*
* @module tool
*/

/**
* provides basic functions for plai tools
*
* @param {Object} schema - js object notation schema defining the tools necessities for
* settings, cue properties and if tool uses collections, creating new items
*/
class Tool {
  constructor(schema) {
    if (schema) {
      this.schema = schema
    } else {
      this.schema = {
        settings: {},
        cue: {}
      }
    }

  }

  /**
  *
  * is called once after the tool is required by the game
  * creates collections as objects and in database if schema defines them
  *
  * @param {string} config.game - Name of game that required this module 
  * @param {Object} config.db - Game Databse collection connector
  * @param {Object} config.app - Express app instance
  * @param {Object} config.socket - socket.io namespace routed to /&lt;toolname>
  * @param {string} config.url - external webaddress as entered by user directing to node server
  */
  setup(config) {
    return new Promise(function (resolve, reject) {
      Object.assign(this, config)
      if (this.schema.hasOwnProperty("collections")) {
        for (let collection in this.schema.collections) {
          if (!this.db.hasOwnProperty(collection)) {
            this.db.addCollection(collection)
              .then(function (result) {
                this[collection] = new Collection(this.schema.collections[collection], this.db[collection])
                resolve()
              }.bind(this))
              .catch(function (error) {
                reject(error)
              }.bind(this))
          } else {
            this[collection] = new Collection(this.schema.collections[collection], this.db[collection])
            resolve()
          }
        }
      }
    }.bind(this))
  }

  /**
  * called when cue was triggered that contains any property of this tool
  * if a listener type is cued, cue may return data that will be stored and recalled
  * whenever the listener is retriggered or canceled
  *
  * @param {Object} data - cue data entered by user
  */
  cue(data) {
    log.warn(this.name, "received cue data but cue function not specified:")
    log.warn(this.name, data)
  }

  /**
  * called when a session wants to cancel a listener
  *
  * @param {Object} listener - all data that was stored about the listener
  */
  cancel(listener) {
    log.warn(this.name, "received cancel command but cancel function not specified:")
    log.warn(this.name, listener)
  }

  /**
  * called when settings based on the schema the module provides, are changed
  *
  * @param {Object} new_settings - changed settings based on perferences schema of this tool
  */
  settings(new_settings) {

  }

  /**
  * is called the moment the tool was disabled in a game
  *
  * @param {string} config.game - Name of game that required this module
  */
  removed(config) {

  }

  /**
  * handle commands forwarded by game
  */
  command(input) {
    switch (input[0]) {
      default:
        if (this.hasOwnProperty(input[0])) {
          let coll = input.shift()
          this[coll].command(input)
        } else if (this.schema.hasOwnProperty("collections")) {
          if (Object.keys(this.schema.collections).length == 1) {
            for (let col in this.schema.collections) {
              this[col].command(input)
            }
          } else {
            log.info(this.name, "No such collection or command '" + input[0] + "'")
          }
        } else {
          log.info(this.name, "No such collection or command '" + input[0] + "'")
        }
        break
    }
  }

  /**
  * write changed schema to tool document in tools database
  */
  schemaUpdate(schema) {
    this.schema = schema
    this.db.tools.set({ name: this.name }, { schema: schema })
  }
}

/**
* provides useful functions for tools that use collections to create and maintain items.
* 
* @param {Object} schema - containing schemes for collection items
* @param {Object} db_coll - mongodb access to collection in game database
*/
class Collection {
  constructor(schema, db_coll) {
    this.schema = schema
    this.items = []
    this.db_coll = db_coll
    
    this.name = this.db_coll.name
    
    let coll_change_stream = db_coll.changes({ fullDocument: 'updateLookup' })
    coll_change_stream.on("change", this.review.bind(this))
  }

  /**
  * check db for item list and create instance for each record
  */
  collectItems() {
    return new Promise(function (resolve, reject) {
      this.db_coll.find({})
        .then(function (items) {
          for (let item of items) {
            this.add(item)
          }
          resolve(true)
        }.bind(this))
    }.bind(this))
  }
  
  /**
  * walk through items and look for matching key
  *
  * @param {string} key - key to look up
  * @param value - value in key to match
  *
  * @returns {Tool} first item Object that has key:value. undefined if no item was found.
  */
  findItem(key, value) {
    for(let item in this.items) {
      if(this.items[item].hasOwnProperty(key)) {
        if(this.items[item][key] == value) {
          return this.items[item]
        } else if (key == "_id") {
          if(this.db_coll.compareIDs(this.items[item]._id, value)) {
            return this.items[item]
          }
        }
      }
    }
    log.warn(this.name, "no item found with " + key + ": '" + value + "'")
    return undefined
  }


  /**
  * on change in db collection, check for updates of settings or name
  *
  * @todo for items that create extra properties in the local object mongo replace leeds to
  * reporting changes that are not actually there
  *
  * create new item on insert
  * remove item on delete
  *
  * @param {Object} change - mongo change Event Object. See {@link https://docs.mongodb.com/manual/reference/change-events/#change-stream-output}
  */
  review(change) {
    // log.debug(this.name, change.operationType + " operation in devices collection")
    switch (change.operationType) {
      case 'insert':
        this.add(change.fullDocument)
        break

      case "replace":
      case "update":
        let item = this.findItem("_id", change.documentKey._id)
        
        if(!item) {
          log.error(this.name, "Failed to update. Item missing: " + change.fullDocument.name + " _id: " + change.documentKey._id)
          return
        }
        
        let changes = {updated:{},removed:[]}
        
        if(change.hasOwnProperty("updateDescription")) {
          if(change.updateDescription.hasOwnProperty("updatedFields")) {
            changes.updated = change.updateDescription.updatedFields
          }
          if(change.updateDescription.hasOwnProperty("removedFields")) {
            changes.removed = change.updateDescription.removedFields
          }
        } else {
          changes = Object.changes(item, change.fullDocument)
        }
        changes["document"] = change.fullDocument
        
        if(changes.updated.hasOwnProperty("settings")) {
          if(typeof item.reconnect === "function") {
            log.debug(item.name, "settings changed: ")
            log.debug(item.name, changes.document.settings)
            item.reconnect(changes.document.settings)
          } else {
            log.warn(this.name, item.name + " settings have changed but item does not own a reconnect function to apply them.")
          }
        }
        
        this.update(item.name, changes)
        
        if(item.name != changes.document.name) {
          log.debug(item.name, " name changed to " + changes.document.name)
          this.items[changes.document.name] = item
          item.name = changes.document.name
          delete this.items[item.name]
        }
        break

      case 'delete':
        for (let item in this.items) {
          if (this.db_coll.compareIDs(this.items[item]._id, change.documentKey._id)) {
            this.remove(item)
            break
          }
        }
        break
    }
  }

  /**
  * add an item to collection. Overwrite this function by child when you
  * want to add items of custom type/class
  */
  add(data) {
    this.items[data.name] = new Item(data, this.db_coll)
    log.info("ADD ITEM", data.name)
  }

  /**
  * call close function and delete item from collection Object
  */
  remove(item) {
    this.items[item].close()
    delete this.items[item]
    log.debug(this.name, "Item removed: " + item)
  }

  /**
  * abstract function
  * changes happened for one of the items.
  */
  update(item, changes, document) {

  }

  /**
  * Get command forwarded from tool. If you defined a custom command function you can still call this
  * (super.command(input)) to forward commands to colleciton items.
  */
  command(input) {
    switch (input[0]) {
      default:
        if (this.items.hasOwnProperty(input[0])) {
          let item = input.shift()
          if (typeof this.items[item].command === "function") {
            this.items[item].command(input)
          } else {
            log.warn(this.name, item + " has no command function")
          }
        } else if (Object.keys(this.items).length == 1) {
          for (let item in this.items) {
            if (typeof this.items[item].command === "function") {
              this.items[item].command(input)
            } else {
              log.warn(this.name, item + " has no command function")
            }
          }
        } else {
          log.info(this.name, "No such item or command '" + input[0] + "'")
        }
        break
    }
  }
}

/**
* provides basic functions for items plai tools might inherit
*/
class Item {
  constructor(data, coll) {

  }

  /**
  * is called once the Item was removed from collection
  */
  close() {

  }

  /**
  * is called once settings property for this item are changed
  */
  reconnect(settings) {

  }

  /**
  * is called once any property for this item has changed
  */
  update(data) {

  }

  command(input) {
    log.warn(this.name, "no command function specified")
  }


}

module.exports = {
  Tool: Tool,
  Collection: Collection,
  Item: Item
}
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tool.html">tool</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-tool-Collection.html">Collection</a></li><li><a href="module-tool-Item.html">Item</a></li><li><a href="module-tool-Tool.html">Tool</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Thu Dec 12 2019 19:18:46 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
